package com.developpez.olegoaer.rpc;

import org.apache.http.HttpEntity;
import org.apache.http.HttpResponse;
import org.apache.http.client.HttpClient;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.util.EntityUtils;

import android.app.ProgressDialog;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.os.AsyncTask;
import android.util.Log;

import com.developpez.olegoaer.screen.ImageScreen;

public class DownloadImage extends AsyncTask<String, Void, Bitmap> {

	private static final String BASE_URL = "http://chart.apis.google.com/chart";
	
	private volatile ImageScreen screen;
	private HttpClient client;
	private ProgressDialog progress;
	
	public DownloadImage(ImageScreen s) {
		this.screen = s;	
		this.client = new DefaultHttpClient();
		this.progress = new ProgressDialog(this.screen);
	}
	
	@Override
	protected void onPreExecute() {
		super.onPreExecute();		      		     
		this.progress.setTitle("Veuillez patientez");
		this.progress.setMessage("Rcupration de l'image en cours...");
		this.progress.setProgressStyle(ProgressDialog.STYLE_SPINNER);	  
		this.progress.show();
	}
	
	@Override
	protected Bitmap doInBackground(String... params) {
	
		Bitmap dummyImage = null;
		
		try {
			
			String url = String.format("%s?cht=%s&chs=%s&chl=%s", BASE_URL, params[0], params[1], params[2]);		
			HttpGet request = new HttpGet(url);
			HttpResponse response = this.client.execute(request);	
			HttpEntity entity = response.getEntity();
			byte[] bytes = EntityUtils.toByteArray(entity);
			dummyImage = BitmapFactory.decodeByteArray(bytes, 0, bytes.length);
						
		} catch (Exception e) { Log.e("RPC","Exception leve", e); }
		
		return dummyImage;
	}

	@Override
	protected void onPostExecute(Bitmap result) {
		
		super.onPostExecute(result);
		
		if(this.progress.isShowing())
			this.progress.dismiss();
		
		this.screen.populate(result);
	}
	
}
